### tsp_greedy.py

import random
import math

### ===== Zufallsgenerator-setzen ===================================
# Setzt den Zufallsgenerator
# Das fuehrt bei erneutem Aufruf zur selben Folge
#random.seed(100)
# gesetzt mit aktueller Zeit:
random.seed()

### ===== Erzeugen derStaedtliste ====================================
# ----- globale Variable
# Das Programm verwendet einige globale Variable:
# - Groesse der Bilschirmdarstellung:
bildGroesse = 800
# - Anzahl der Städte:
anzahlStaedte = 20
# ----- eine Stadt ist ein Zahlenpaar
def erzeugeEineStadt():
    return random.randint(1,bildGroesse-2),random.randint(1,bildGroesse-2)
# ----- gibt eine Liste aller Städte zurück
def erzeugeAlleStaedte(anzahlStaedte=anzahlStaedte):
    ## greift auf die globale Variable zu
    staedte = []
    i = anzahlStaedte
    while i>0:
        stadt = erzeugeEineStadt()
        if not(stadt in staedte):
            staedte.append(stadt)
            i-=1
    return staedte
# Eine globale Variable fuer Testzwecke
staedteListe = erzeugeAlleStaedte()
###Tests:
##print(erzeugeEineStadt())
##print(erzeugeAlleStaedte())


class Knoten():
    def __init__(self,x,y):
        self.x,self.y=x,y

    def gibDaten(self):
        return self.x,self.y

class Kante():
    def __init__(self, knoten1, knoten2):
        self.knoten1, self.knoten2 = knoten1, knoten2

    def gibDieKnoten(self):
        return self.knoten1, self.knoten2

    def enthaelt(self, knoten):
        return knoten in (self.knoten1, self.knoten2)

    def laenge(self):
        x1,y1=self.knoten1.gibDaten()
        x2,y2=self.knoten2.gibDaten()
        return math.sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))

    def andererKnoten(self, knoten):
        if knoten==self.knoten1: return self.knoten2
        return self.knoten1

### globale Funtion fuer die Prioritaetswarteschlange
def vor(kante1,kante2):
    return kante1.laenge() < kante2.laenge()

### ===== fuege_eines_ein =====
# fuegt ein Element in die Prio-Schlange ein
# benötigt das Praedikat vor
def fuege_eines_ein(eines, vor, priows):
    for i in range(len(priows)):
        if vor(eines, priows[i]):
            return priows[:i] + [eines] + priows[i:]
    return priows + [eines]

### ===== fuege_alle_ein =====
# fuegt alle uebergebenen Elemente in die Prio-Schlange ein
def fuege_alle_ein(alle, vor , priows):
    for eines in alle:
        priows=fuege_eines_ein(eines, vor, priows)
    return priows


### ===== TSP ==============================
class TSP():
    def __init__(self,tspGraph,anzahl=20):
        self.anzahl=anzahl
        self.knoten=[]
        self.erzeugeKnoten()
        self.kanten=[]
        self.weg=[]
        self.tspGraph=tspGraph

    def erzeugeKnoten(self):
        paare=erzeugeAlleStaedte(self.anzahl)
        for paar in paare:
            self.knoten.append(Knoten(paar[0],paar[1]))

    def zeigeKnoten(self):
        knotenDaten=[]
        for knoten in self.knoten:
            knotenDaten.append(knoten.gibDaten())
        print(knotenDaten)

    def verbindeAlle(self):
        ### verknuepft alle Knoten zu einem Graphen.
        for i in range(self.anzahl):
            for j in range(self.anzahl):
                if i!=j:
                    self.kanten.append(Kante(self.knoten[i],
                                             self.knoten[j]))
        daten=[]
        for knoten in self.knoten:
            daten.append(knoten.gibDaten())
        self.tspGraph.setzeDaten(daten)

    def gibSortierteNachfolgeKanten(self, knoten):
        alleSortiert=[]
        for kante in self.kanten:
            if kante.enthaelt(knoten):
                alleSortiert=fuege_eines_ein(kante, vor, alleSortiert)
        return alleSortiert

    def greedySuche(self):
        # sucht greedy einen Rundweg
        start=self.knoten[0]
        self.weg=[start]
        aktuelleKante=self.gibSortierteNachfolgeKanten(start)[0]
        weiter=aktuelleKante.andererKnoten(start)
        self.weg.append(weiter)
        while len(self.weg)<self.anzahl:
            neueKanten=self.gibSortierteNachfolgeKanten(weiter)
            self.kanten.remove(neueKanten[0])
            weiter=neueKanten[0].andererKnoten(weiter)
            while (weiter in self.weg) or (weiter==start):
                neueKanten=neueKanten[1:]
                weiter=neueKanten[0].andererKnoten(weiter)
            self.weg.append(weiter)
        self.weg.append(start)
        self.kanten=[]
        for i in range(len(self.weg)-1):
            self.kanten.append(Kante(self.weg[i],self.weg[i+1]))
        daten=[]
        for ort in self.weg:
            daten.append(ort.gibDaten())
        self.tspGraph.setzeDaten(daten)
            
